[PACKAGE]: ../../raw/master/mkp/snmp_configuration-0.0.5-20230804.mkp "snmp_configuration-0.0.5-20230804.mkp"
# SNMP Configuration

This plugin is intended to help you keep track of the SNMP configuration CheckMK is using to monitor your hosts.\
It will generate alerts for old/bad SNMP configurations. Via WATO you can configure what old/bad means for you.

---
### Download

* [Download latest mkp file][PACKAGE]

**Note**: before you update to a newer version, always check the [CHANGELOG](CHANGELOG). There might be incompatible changes.

---                   
### Installation

You can install the package by uploading it to your CheckMK site and as site user run 
```
mkp install PACKAGENAME-VERSION.mkp
```
or beginning with CMK2.2.x
```
mkp add PACKAGENAME-VERSION.mkp
mkp enable PACKAGENAME VERSION
```
In the non RAW editions of CheckMK you can use the GUI to install the package (_Setup_ -> _Extension Packages_ -> _Upload package_)

---
### Want to contribute?

Nice ;-) Have a look at the [contribution guidelines](CONTRIBUTING.md "Contributing")

---
### Check Info

The plugin creates the service **_SNMP Configuration_** for each host with SNMP enabled

<details><summary>Montoring states</summary>

| State | condition | WATO | 
| ------ | ------ | ------ |
| WARN | if SNMP version not in list | yes |
| WARN | if SNMPv3 level is not list | yes |
| WARN | if SNMPv3 authentication is not in list| yes |
| WARN | if SNMPv3 encryption is not in list| yes |
| WARN | if SNMP backend not in list | yes |
| WARN | if key length below minimal key length | yes |
| WARN | if authentication and encryption keys are identical | yes |
| WARN | if key default key is used | yes |
| WARN | if key complexity not met | yes |

</details>

---
### WATO
<details><summary>Service monitoring rule</summary>

| Section | Rule name |
| ------ | ------ |
| Applications, Processes & Services | Checkmk SNMP Configuration  |

| Option | Defailt value |
| ------ | ------ |
| Report only | Disabled |
| SNMP Version | Version 3 |
| Monitoring state if version not in list | WARN |
| SNMP v3 level | authentication and privacy |
| Monitoring state if level is not list | WARN |
| SNMP v3 authentication | SHA, SHA-224, SHA-256, SHA-384, SHA-512 |
| Monitoring state if authentication is not in list | WARN |
| SNMP v3 encryption | AES-128 |
| Monitoring state if encryption is not in list | WARN |
| SNMP backend | Inline, Classic |
| Monitoring state if backend not in list | WARN |
| Minimal key length | 10 |
| Monitoring state if key length below minimal key length | WARN |
| Monitoring state when authentication and encryption keys are identical | WARN |
| Check default key values | public, private |
| Check reversed keys | Enabled |
| Monitoring state if key used is a default key | WARN |
| Key complexity | Digit, Lowecase, Uppercase, Special, no repeated chars |
| Monitoring state if key complexity not met | WARN |


</details> 

---
### Sample Output

Sample output (Report only enabled)

![sample output](img/sample.png?raw=true "sample output")

Sample output details

![sample output details](img/sample-details.png?raw=true "sample output details")

